#include <string.h>
#include <config.h>

#include <wine/driver.h>
#include <wine/vfw.h>

#include <gst/gst.h>

int main(int argc,char *argv[]) 
{
  COMPVARS m_cv;
  BITMAPINFOHEADER m_bh, m_obh;
  HRESULT h;

  gst_init(&argc, &argv);

  if (!gst_library_load("winloader")) {
    gst_info("codectest: could not load support library: 'winloader'\n");
    return -1;
  }
  gst_info("winloader loaded\n");
  
  memset(&m_cv, 0, sizeof(m_cv));
  memset(&m_bh, 0, sizeof(m_bh));

  m_bh.biSize = 40;
  m_bh.biWidth = 640;
  m_bh.biHeight = 480;
  m_bh.biPlanes = 1;
  m_bh.biBitCount = 24;
  m_bh.biCompression = mmioFOURCC('D', 'I', 'V', '3'); /* div3 */
  //m_bh.biCompression = mmioFOURCC('I', 'V', '5', '0'); /* div3 */
  m_bh.biSizeImage = 921600;

  memset(&m_obh, 0, sizeof(m_obh));
  m_obh.biSize=sizeof(m_obh);
  m_cv.cbSize=sizeof(m_cv);
  gst_info("trying to open library\n");
  m_cv.hic=ICOpen(
          0x63646976,//vidc
          m_bh.biCompression,
          ICMODE_DECOMPRESS);
  if(m_cv.hic==0)
  {
    printf("VideoDecoder:: ICOpen failed\n");
    return -1;
  }
  m_cv.fccType=0x63646976;
  m_cv.fccHandler=m_bh.biCompression;

  h=ICDecompressGetFormat(m_cv.hic, &m_bh, &m_obh);
  if(h!=0)
  {
    printf("VideoDecoder:: Can't handle this format\n");
    ICClose(m_cv.hic);
    return -1;
  }
  
  return 0;
}
