/* Gnome-Streamer
 * Copyright (C) <1999> Erik Walthinsen <omega@cse.ogi.edu>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#include <string.h>

//#define DEBUG_ENABLED
#include <gstaviencoder.h>

gst_riff_strf_vids *gst_aviencoder_make_video_header(guint32 codec, guint width, guint height, guint planes, guint bit_cnt) 
{
  gst_riff_strf_vids *strf_vids = g_malloc(sizeof(gst_riff_strf_vids));

  memset(strf_vids, 0, sizeof(gst_riff_strf_vids));
  strf_vids->size = sizeof(gst_riff_strf_vids);
  strf_vids->width = width;
  strf_vids->height = height;
  strf_vids->planes = planes;
  strf_vids->bit_cnt = bit_cnt;

  strf_vids->compression = codec;

  switch (codec) {
    case GST_RIFF_MJPG:
    case GST_RIFF_mJPG:
      strf_vids->bit_cnt = 24;
      strf_vids->image_size = width*height*(bit_cnt/8);
      break;
    case GST_RIFF_I420:
    case GST_RIFF_YV12:
      strf_vids->bit_cnt = 12;
      strf_vids->image_size = width*height+width*height/2;
    case GST_RIFF_DIV3:
      strf_vids->bit_cnt = 24;
      strf_vids->image_size = width*height*3;
      break;
  }

  return strf_vids;
}

