/* Gnome-Streamer
 * Copyright (C) <1999> Erik Walthinsen <omega@cse.ogi.edu>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */


#ifndef __GST_WINENC_H__
#define __GST_WINENC_H__


#include <config.h>
#include <gst/gst.h>
#include <gst/meta/videoraw.h>
#include <libs/colorspace/gstcolorspace.h>

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */


#define GST_TYPE_WINENC \
  (gst_winenc_get_type())
#define GST_WINENC(obj) \
  (GTK_CHECK_CAST((obj),GST_TYPE_WINENC,GstWinEnc))
#define GST_WINENC_CLASS(klass) \
  (GTK_CHECK_CLASS_CAST((klass),GST_TYPE_WINENC,GstWinEnc))
#define GST_IS_WINENC(obj) \
  (GTK_CHECK_TYPE((obj),GST_TYPE_WINENC))
#define GST_IS_WINENC_CLASS(obj) \
  (GTK_CHECK_CLASS_TYPE((klass),GST_TYPE_WINENC))

typedef struct _GstWinEnc GstWinEnc;
typedef struct _GstWinEncClass GstWinEncClass;

struct _GstWinEnc {
  GstElement element;

  /* pads */
  GstPad *sinkpad,*srcpad;

  // video state
  gint format;
  gint width;
  gint height;
  // the video buffer
  gint bufsize;
  GstBuffer *buffer;

  gboolean inited;

  gpointer extra_data;
  gint bitrate, quality;
  gulong compression;

  gulong last_frame_size;

  GstColorSpaceConverter *converter;

};

struct _GstWinEncClass {
  GstElementClass parent_class;

  /* signals */
  void (*frame_encoded) (GstElement *element, GstPad *pad);
};

GtkType gst_winenc_get_type(void);


#ifdef __cplusplus
}
#endif /* __cplusplus */


#endif /* __GST_WINENC_H__ */
