/* Gnome-Streamer
 * Copyright (C) <1999> Erik Walthinsen <omega@cse.ogi.edu>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */


#ifndef __MP3PARSE_H__
#define __MP3PARSE_H__


#include <config.h>
#include <gst/gst.h>


#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */


#define GST_TYPE_MP3PARSE \
  (mp3parse_get_type())
#define GST_MP3PARSE(obj) \
  (GTK_CHECK_CAST((obj),GST_TYPE_MP3PARSE,Mp3Parse))
#define GST_MP3PARSE_CLASS(klass) \
  (GTK_CHECK_CLASS_CAST((klass),GST_TYPE_MP3PARSE,Mp3Parse))
#define GST_IS_MP3PARSE(obj) \
  (GTK_CHECK_TYPE((obj),GST_TYPE_MP3PARSE))
#define GST_IS_MP3PARSE_CLASS(obj) \
  (GTK_CHECK_CLASS_TYPE((klass),GST_TYPE_MP3PARSE))

typedef struct _Mp3Parse Mp3Parse;
typedef struct _Mp3ParseClass Mp3ParseClass;

struct _Mp3Parse {
  GstElement element;

  GstPad *sinkpad,*srcpad;

  GstBuffer *partialbuf;	// previous buffer (if carryover)
  guint skip; /* number of frames to skip */
  guint bit_rate;
  gboolean in_flush;
};

struct _Mp3ParseClass {
  GstElementClass parent_class;
};

GtkType gst_mp3parse_get_type(void);


#ifdef __cplusplus
}
#endif /* __cplusplus */


#endif /* __MP3PARSE_H__ */
