/* Gnome-Streamer
 * Copyright (C) <1999> Erik Walthinsen <omega@cse.ogi.edu>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */


#include <rtjpegdec.h>



/* elementfactory information */
GstElementDetails rtjpegdec_details = {
  "RTjpeg decoder",
  "Filter/Video/Decoder",
  "Decodes video in RTjpeg format",
  VERSION,
  "Erik Walthinsen <omega@cse.ogi.edu>",
  "(C) 1999",
};

/* RTJpegDec signals and args */
enum {
  /* FILL ME */
  LAST_SIGNAL
};

enum {
  ARG_0,
  ARG_QUALITY,
};


static void	gst_rtjpegdec_class_init	(RTJpegDecClass *klass);
static void	gst_rtjpegdec_init		(RTJpegDec *rtjpegdec);

static void	gst_rtjpegdec_chain		(GstPad *pad, GstBuffer *buf);

static GstElementClass *parent_class = NULL;
//static guint gst_rtjpegdec_signals[LAST_SIGNAL] = { 0 };

GtkType
rtjpegdec_get_type (void)
{
  static GtkType rtjpegdec_type = 0;

  if (!rtjpegdec_type) {
    static const GtkTypeInfo rtjpegdec_info = {
      "RTJpegDec",
      sizeof(RTJpegDec),
      sizeof(RTJpegDecClass),
      (GtkClassInitFunc)gst_rtjpegdec_class_init,
      (GtkObjectInitFunc)gst_rtjpegdec_init,
      (GtkArgSetFunc)NULL,
      (GtkArgGetFunc)NULL,
      (GtkClassInitFunc)NULL,
    };
    rtjpegdec_type = gtk_type_unique(GST_TYPE_ELEMENT,&rtjpegdec_info);
  }
  return rtjpegdec_type;
}

static void
gst_rtjpegdec_class_init (RTJpegDecClass *klass)
{
  GstElementClass *gstelement_class;

  gstelement_class = (GstElementClass*)klass;

  parent_class = gtk_type_class(GST_TYPE_ELEMENT);
}

static void
gst_rtjpegdec_init (RTJpegDec *rtjpegdec)
{
  rtjpegdec->sinkpad = gst_pad_new("sink",GST_PAD_SINK);
  gst_element_add_pad(GST_ELEMENT(rtjpegdec),rtjpegdec->sinkpad);
  gst_pad_set_chain_function(rtjpegdec->sinkpad,gst_rtjpegdec_chain);
  rtjpegdec->srcpad = gst_pad_new("src",GST_PAD_SRC);
  gst_element_add_pad(GST_ELEMENT(rtjpegdec),rtjpegdec->srcpad);
}

static void
gst_rtjpegdec_chain (GstPad *pad, GstBuffer *buf)
{
  RTJpegDec *rtjpegdec;
  guchar *data;
  gulong size;

  g_return_if_fail (pad != NULL);
  g_return_if_fail (GST_IS_PAD (pad));
  g_return_if_fail (buf != NULL);

  rtjpegdec = GST_RTJPEGDEC (GST_OBJECT_PARENT (pad));
  data = GST_BUFFER_DATA(buf);
  size = GST_BUFFER_SIZE(buf);

  gst_info("would be encoding frame here\n");

  gst_pad_push(rtjpegdec->srcpad,buf);
}
