/* Gnome-Streamer
 * Copyright (C) <1999> Erik Walthinsen <omega@cse.ogi.edu>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */


#include <rtjpegenc.h>

/* elementfactory information */
GstElementDetails rtjpegenc_details = {
  "RTjpeg encoder",
  "Filter/Video/Encoder",
  "Encodes video in RTjpeg format",
  VERSION,
  "Erik Walthinsen <omega@cse.ogi.edu>",
  "(C) 1999",
};

/* RTJpegEnc signals and args */
enum {
  /* FILL ME */
  LAST_SIGNAL
};

enum {
  ARG_0,
  ARG_QUALITY,
};


static void	gst_rtjpegenc_class_init	(RTJpegEncClass *klass);
static void	gst_rtjpegenc_init		(RTJpegEnc *rtjpegenc);

static void	gst_rtjpegenc_chain		(GstPad *pad, GstBuffer *buf);

static GstElementClass *parent_class = NULL;
//static guint gst_rtjpegenc_signals[LAST_SIGNAL] = { 0 };

GtkType
rtjpegenc_get_type (void)
{
  static GtkType rtjpegenc_type = 0;

  if (!rtjpegenc_type) {
    static const GtkTypeInfo rtjpegenc_info = {
      "RTJpegEnc",
      sizeof(RTJpegEnc),
      sizeof(RTJpegEncClass),
      (GtkClassInitFunc)gst_rtjpegenc_class_init,
      (GtkObjectInitFunc)gst_rtjpegenc_init,
      (GtkArgSetFunc)NULL,
      (GtkArgGetFunc)NULL,
      (GtkClassInitFunc)NULL,
    };
    rtjpegenc_type = gtk_type_unique(GST_TYPE_ELEMENT,&rtjpegenc_info);
  }
  return rtjpegenc_type;
}

static void
gst_rtjpegenc_class_init (RTJpegEncClass *klass)
{
  GstElementClass *gstelement_class;

  gstelement_class = (GstElementClass*)klass;

  parent_class = gtk_type_class(GST_TYPE_ELEMENT);
}

static void
gst_rtjpegenc_init (RTJpegEnc *rtjpegenc)
{
  rtjpegenc->sinkpad = gst_pad_new("sink",GST_PAD_SINK);
  gst_element_add_pad(GST_ELEMENT(rtjpegenc),rtjpegenc->sinkpad);
  gst_pad_set_chain_function(rtjpegenc->sinkpad,gst_rtjpegenc_chain);
  rtjpegenc->srcpad = gst_pad_new("src",GST_PAD_SRC);
  gst_element_add_pad(GST_ELEMENT(rtjpegenc),rtjpegenc->srcpad);
}

static void
gst_rtjpegenc_chain (GstPad *pad, GstBuffer *buf)
{
  RTJpegEnc *rtjpegenc;
  guchar *data;
  gulong size;

  g_return_if_fail(pad != NULL);
  g_return_if_fail(GST_IS_PAD(pad));
  g_return_if_fail(buf != NULL);

  rtjpegenc = GST_RTJPEGENC (GST_OBJECT_PARENT (pad));
  data = GST_BUFFER_DATA(buf);
  size = GST_BUFFER_SIZE(buf);

  gst_info("would be encoding frame here\n");

  gst_pad_push(rtjpegenc->srcpad,buf);
}
