/* Gnome-Streamer
 * Copyright (C) <1999> Erik Walthinsen <omega@cse.ogi.edu>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */


#define HAVE_LIBXXF86DGA

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xproto.h>
#include <X11/Xmd.h>
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Xatom.h>
#include <X11/Shell.h>

#ifdef HAVE_LIBXXF86DGA
# include <X11/extensions/xf86dga.h>
# include <X11/extensions/xf86dgastr.h>
#endif

#include <gdk/gdk.h>
#include <gdk/gdkx.h>
#include <sys/time.h>

//#define DEBUG_ENABLED
#include <gst/meta/videoraw.h>
#include "dga.h"

gboolean gst_videosink_dga_init(GstVideoSink *sink) {
#if 0
//#ifdef HAVE_LIBXXF86DGA
  int  flags,foo,bar,ma,mi;
  int  *base, width, bs, rs;
  Display *dpy = GDK_DISPLAY();

  if (XF86DGAQueryExtension(dpy,&foo,&bar)) {
    XF86DGAQueryDirectVideo(dpy,XDefaultScreen(dpy),&flags);
    if (flags & XF86DGADirectPresent) {
      XF86DGAQueryVersion(dpy,&ma,&mi);
      fprintf(stderr,"DGA: version %d.%d\n",ma,mi);
      XF86DGAGetVideoLL(dpy,XDefaultScreen(dpy), (int*)&base, &width, &bs, &rs);
      fprintf(stderr,"DGA: base:%p  width:%d  bank_size:%d  ram_size:%d\n",base, width, bs, rs);
      if (sink->meta.dga_info == NULL) {
        sink->meta.dga_info = &sink->meta_dga;
        fprintf(stderr, "DGA: preparing structures\n");
      }
      sink->meta.dga_info->base = base;
      sink->meta.dga_info->swidth = gdk_screen_width();
      sink->meta.dga_info->sheight = gdk_screen_height();
      sink->meta.dga_info->bytes_per_line = (gdk_visual_get_best_depth()+7)/8 * gdk_screen_width();
      fprintf(stderr,"DGA: screen resolution %dx%d, %d bytes/line\n", sink->meta.dga_info->swidth, 
		                        sink->meta.dga_info->sheight,
              				sink->meta.dga_info->bytes_per_line);
      return TRUE;
    }
  }
#endif
  return FALSE;
}
