#ifndef __GDK_XVIMAGE_H__
#define __GDK_XVIMAGE_H__

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#include <gdk/gdk.h>

typedef struct _GdkXvImage	      GdkXvImage;
typedef struct _GdkXvImagePrivate     GdkXvImagePrivate;
typedef guint64                       GdkXvImageType;

struct _GdkXvImage
{
  GdkXvImageType  type;
  GdkByteOrder	byte_order;
  guint16	width;
  guint16	height;
  guint16	depth;
  guint16	bpp;	    /* bytes per pixel */
  guint16	bpl;	    /* bytes per line */
  gpointer	mem;
};

struct _GdkXvImagePrivate
{
  GdkXvImage image;
#ifdef HAVE_LIBXV
  XvImage *ximage;
#else
  gpointer ximage;
#endif
  Display *xdisplay;
  gpointer x_shm_info;
  gint im_adaptor;
  gint im_port;
  gint im_format;

};


void gdk_xvimage_init(void);
gboolean gdk_xvimage_check_xvideo(void);

GdkXvImage*  gdk_xvimage_new    (GdkXvImageType type,
				 gint	      width,
				 gint	      height);
void	   gdk_xvimage_destroy   (GdkXvImage     *image);

void gdk_xvimage_put (GdkDrawable *window,
		     GdkGC	 *gc,
		     GdkXvImage	 *image,
		     gint	  xsrc,
		     gint	  ysrc,
		     gint	  wsrc,
		     gint	  hsrc,
		     gint	  xdest,
		     gint	  ydest,
		     gint	  wdest,
		     gint	  hdest);

#ifdef __cplusplus
}
#endif /* __cplusplus */


#endif /* __GDK_XVIMAGE_H__ */
