
#include <config.h>

#include <gnome.h>
#include <gst/gst.h>
#include <gdk/gdk.h>
#include <gdk/gdkx.h>

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xproto.h>
#include <X11/Xmd.h>
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Xatom.h>
#include <X11/Shell.h>
#include <X11/Xaw/Simple.h>

#ifdef HAVE_LIBXV
# include <X11/extensions/Xv.h>
# include <X11/extensions/Xvlib.h>
#endif

#include "gtkoverlayimage.h"
#include "gtkxvimage.h"

GdkXvImage *xvimage;
GtkWidget  *gtk_draw;

void my_events(GdkEvent *event, gpointer data) {
  fprintf (stderr, "event received %d\n", event->type);
}

void overlay_change(GtkWidget *widget, MetaOverlay *meta) {
  gint i;

  fprintf (stderr, "overlay_change received %d\n", meta->clip_count);

  for (i=0; i<meta->clip_count; i++) {
    fprintf (stderr, "clip %d %d %d %d\n", meta->overlay_clip[i].x1,
                                           meta->overlay_clip[i].x2,
                                           meta->overlay_clip[i].y1,
                                           meta->overlay_clip[i].y2);
  }
}

gboolean idle_func(gpointer data) 
{
  int i;
  guchar *ptr = xvimage->mem;

  for (i=0; i< 40000; i++)
  {
    *ptr++ += i;
  }
  gtk_xvimage_redraw(GTK_XVIMAGE(data));
  usleep(40000);
  return TRUE;
}

int main(int argc,char *argv[]) {

  GtkWidget *appwindow;
  GdkWindow *window;
  GdkImage  *gdk_image;
  int i;
  GdkRectangle update_rect;
  GdkWindowAttr attr;
  GtkWindow *g_window;
  GtkWidget *vbox1;
  GtkWidget *hbox1;
  GtkWidget *button;
  GtkWidget *button2;

  update_rect.x = 0;
  update_rect.y = 0;
  update_rect.width = 100;
  update_rect.height = 100;


  gdk_init(&argc, &argv);
  gdk_xvimage_init();
  gdk_rgb_init();
  gnome_init("MPEG1 Video player","0.0.1",argc,argv);
  appwindow = gnome_app_new("MPEG1 player","MPEG1 player");

  attr.window_type = GDK_WINDOW_PIXMAP;
  attr.event_mask = GDK_VISIBILITY_NOTIFY_MASK|GDK_STRUCTURE_MASK|GDK_SUBSTRUCTURE_MASK;
  attr.x = 500;
  attr.y = 500;
  attr.width = 200;
  attr.height = 200;

  vbox1 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox1);
  hbox1 = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox1);

  button = gtk_button_new_with_label(_("test"));//_with_label (_("chup"));
  gtk_widget_show (button);
  gtk_box_pack_start (GTK_BOX (vbox1), button, FALSE, FALSE, 0);
  gtk_widget_set_usize (button, 50, 50);

  button2 = gtk_button_new_with_label(_("test2"));//_with_label (_("chup"));
  gtk_widget_show (button2);
  gtk_box_pack_start (GTK_BOX (hbox1), button2, FALSE, FALSE, 0);
  gtk_widget_set_usize (button, 50, 50);

  gtk_box_pack_start (GTK_BOX (vbox1), hbox1, TRUE, TRUE, 0);
	
  xvimage = gdk_xvimage_new(0x32315659, 320, 240);
  gtk_draw = gtk_xvimage_new(xvimage);
  
  
  //gtk_draw = gtk_overlay_image_new();
  //gtk_signal_connect(GTK_OBJECT(gtk_draw),"overlay-change-notify",
//		     GTK_SIGNAL_FUNC(overlay_change),gtk_draw);

  gtk_widget_show(GTK_WIDGET(gtk_draw));

  gtk_box_pack_start (GTK_BOX (hbox1),
                  GTK_OBJECT(gtk_draw),
    	  	         TRUE, TRUE, 0);
						 
  gnome_app_set_contents(GNOME_APP(appwindow), vbox1);
  gtk_widget_show_all(appwindow);

  //gtk_widget_set_usize(gtk_draw, 320,240);
  //gdk_image = gdk_image_get(GTK_WIDGET(gtk_draw)->window, 0, 0, 10, 10);
  //gdk_draw_image(GTK_WIDGET(gtk_draw)->window, NULL,gdk_image,0,0,0,0,100, 100);

  gtk_idle_add(idle_func,gtk_draw);
  gtk_main();

}
